/*  regrid.h -- Define constants for program regrid  */

#define RGD_MODE 0	/* Aggregation function "MODE" */
#define RGD_MEAN 1	/* Aggregation function "MEAN" */
#define RGD_FRACT 2	/* Aggregation function "FRACT" */
#define WOP_IN	0	/* Windowing option "IN" */
#define WOP_OUT 1	/* Windowing option "OUT" */

#define ABORT \
	    c_errmsg ("Aborting on fatal error", "regrid-fatal", &fatal)

struct VTEX	/* Data for one mapping grid vertex */
    {
    double	il;	/* Input line value at vertex*/
    double	is;	/* Input sample value */             
    double	dldl;	/* Derivative of input line with respect to
			   output line, dl(in)/dl(out) */  
    double	dlds;	/* dl(in)/ds(out) */                 
    double	d2l;	/* d2l(in)/dl(out)ds(out) */         
    double	dsdl;	/* ds(in)/dl(out) */                 
    double	dsds;	/* ds(in)/ds(out) */                 
    double	d2s;	/* d2s(in)/dl(out)ds(out) */
    };

struct WTR	/* Data for class weights, thresholds, and realloc. */
    {
    long	wcount;		/* Number of classes having weights */
    long	*wclass;	/* List of classes having weights */
    float	*weight;	/* List of weights, in same order as
				   classes */
    long	tcount;		/* Number of classes having thresholds */
    long	*tclass;	/* List of classes having thresholds */
    float	*thresh;	/* List of threshold values */
    long	rcount;		/* Number of classes being reallocated */
    long	*rclass;	/* List of classes being reallocated */
    long	*nclcnt;	/* Number of new classes for each class
				   being reallocated */
    long	*newcl;		/* List of new classes for each class
				   being reallocated */
    float	*fract;		/* List of fractions of value for each
				   class being reallocated to be given
				   to each new class */
    long	ndflag;		/* Flag set true if NODATA specified */
    double	nodata;		/* NODATA value */
    };
   
